<?xml version="1.0" encoding="ISO-8859-1"?>
<!-- Applied Biosystems-like example stylesheet --> 
<!-- #004799 header background color, text white --> 
<!-- #003366 topic titles --> 
<!-- #e38a22 sub-topic title (orange-yellow) --> 
<!-- #336699 topic text--> 

<html xsl:version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns="http://www.w3.org/1999/xhtml">
  <body style="font-family:Arial,helvetica,sans-serif;font-size:10pt;
        background-color:#FFFFFF">

       <div style="background-color:#004799;color:white;font-size:12pt;font-weight:bold">
        Properties</div>
 
      	<xsl:for-each select="AB_Root/Properties">
        <div style="color:#003366;padding:4px;font-weight:bold">Source: <span style="color:#336699;font-weight:normal"><xsl:value-of select="Data_Source"/></span></div>
     	<div style="color:#003366;padding:4px;font-weight:bold">Source Last Modified: <span style="color:#336699;font-weight:normal"><xsl:value-of select="Data_Source_Last_Modified"/></span></div>
 	</xsl:for-each>

    <xsl:for-each select="AB_Root/Header">
     	<div style="color:#003366;padding:4px;font-weight:bold">Source Type: <span style="color:#336699;font-weight:normal"><xsl:value-of select="ByteOrder"/></span></div>
   	<div style="color:#003366;padding:4px;font-weight:bold">Source Version: <span style="color:#336699;font-weight:normal"><xsl:value-of select="Version"/></span></div>
    </xsl:for-each>

    <xsl:for-each select="AB_Root/Properties">
        <div style="color:#003366;padding:4px;font-weight:bold">XML Created by: <span style="color:#336699;font-weight:normal"><xsl:value-of select="Creator"/></span></div>
        <div style="color:#003366;padding:4px;font-weight:bold">Date Created: <span style="color:#336699;font-weight:normal"><xsl:value-of select="Date_Created"/></span></div>
     </xsl:for-each>
     
             <div style="margin-top:20px; background-color:#004799;color:white;font-size:12pt;font-weight:bold">
        Header</div>
        

    <xsl:for-each select="AB_Root/Header">
     	<div style="color:#003366;padding:4px;font-weight:bold">Instrument Type: <span style="color:#336699;font-weight:normal"><xsl:value-of select="Instrument_Type"/></span></div>
   	<div style="color:#003366;padding:4px;font-weight:bold">Instrument Platform: <span style="color:#336699;font-weight:normal"><xsl:value-of select="Instrument_Platform"/></span></div>
   	<div style="color:#003366;padding:4px;font-weight:bold">Acquisition Status: <span style="color:#336699;font-weight:normal"><xsl:value-of select="Acquisition_Status"/></span></div>
   	<div style="color:#003366;padding:4px;font-weight:bold">Assay Type: <span style="color:#336699;font-weight:normal"><xsl:value-of select="Assay_Type"/></span></div>
     	<div style="color:#003366;padding:4px;font-weight:bold">Run Type: <span style="color:#336699;font-weight:normal"><xsl:value-of select="Run_Type"/></span></div>
   	<div style="color:#003366;padding:4px;font-weight:bold">Plate Code: <span style="color:#336699;font-weight:normal"><xsl:value-of select="Plate_Code"/></span></div>
     	<div style="color:#003366;padding:4px;font-weight:bold">Plate Rows: <span style="color:#336699;font-weight:normal"><xsl:value-of select="Plate_Rows"/></span></div>
   	<div style="color:#003366;padding:4px;font-weight:bold">Plate Columns: <span style="color:#336699;font-weight:normal"><xsl:value-of select="Plate_Columns"/></span></div>
   	<div style="color:#003366;padding:4px;font-weight:bold">Barcode: <span style="color:#336699;font-weight:normal"><xsl:value-of select="Barcode"/></span></div>
    </xsl:for-each>

        <div style="margin-top:20px; background-color:#004799;color:white;font-size:12pt;font-weight:bold">
        Data</div>

 
	<div style="color:#003366;font-weight:bold"> 
        	Plate Size: <xsl:value-of select="AB_Root/Data/Plate_Setup/Plate_Size"/></div>


    <xsl:for-each select="AB_Root/Data/Plate_Setup/Well">

     <div style="color:#336699;padding:4px">
     
	<span style="color:#e38a22;font-weight:normal">Well Name: </span><xsl:value-of select="Name"/>
	<span style="color:#e38a22;font-weight:normal"> Description: </span><xsl:value-of select="Description"/>
	<span style="color:#e38a22;font-weight:normal"> Column: </span><xsl:value-of select="Column"/>
	<span style="color:#e38a22;font-weight:normal"> Row: </span><xsl:value-of select="Row"/>
	<span style="color:#e38a22;font-weight:normal"> Used: </span><xsl:value-of select="Used"/>
      </div>

   <xsl:for-each select="Detector_Task">
         <div style="margin-left:20px;margin-bottom:2px">
        <span style="color:#003366;font-weight:normal;font-style:italic">Detector: </span><xsl:value-of select="Detector"/>
        <span style="color:#003366;font-weight:normal;font-style:italic"> Task: </span><xsl:value-of select="Task"/>
        <span style="color:#003366;font-weight:normal;font-style:italic"> Used: </span><xsl:value-of select="Used"/>
        <span style="color:#003366;font-weight:normal;font-style:italic"> Quantity: </span><xsl:value-of select="Quantity"/>
        </div>
    </xsl:for-each>

    </xsl:for-each>

  
	<div style="color:#003366;font-weight:bold"> 
        	Detectors: <xsl:value-of select="AB_Root/Data/Detectors_List/Detectors_Size"/></div>
    <xsl:for-each select="AB_Root/Data/Detectors_List/Detector">
      <div style="color:#336699;padding:4px">
	   <span style="color:#e38a22;font-weight:normal">Detector ID: </span><xsl:value-of select="ID"/>
	   <span style="color:#e38a22;font-weight:normal"> Detector: </span><xsl:value-of select="Name"/>
	   <span style="color:#e38a22;font-weight:normal"> Reporter: </span><xsl:value-of select="Reporter"/>
	   <span style="color:#e38a22;font-weight:normal"> Quencher: </span><xsl:value-of select="Quencher"/>
	   <span style="color:#e38a22;font-weight:normal"> Description: </span><xsl:value-of select="Description"/>
	   <span style="color:#e38a22;font-weight:normal"> Comment: </span><xsl:value-of select="Comment"/>
	   <span style="color:#e38a22;font-weight:normal"> Owner: </span><xsl:value-of select="Owner"/>
	   <span style="color:#e38a22;font-weight:normal"> Locus: </span><xsl:value-of select="Locus"/>

	   <span style="color:#e38a22;font-weight:normal"> Color: </span><xsl:value-of select="Color"/>
	   <span style="color:#e38a22;font-weight:normal"> Start Baseline: </span><xsl:value-of select="Start_Baseline"/>
	   <span style="color:#e38a22;font-weight:normal"> End Baseline: </span><xsl:value-of select="End_Baseline"/>
	   <span style="color:#e38a22;font-weight:normal"> Threshold: </span><xsl:value-of select="Threshold"/>
	   <span style="color:#e38a22;font-weight:normal"> AutoCT Quality: </span><xsl:value-of select="AutoCT_Quality"/>
	   <span style="color:#e38a22;font-weight:normal"> AutoCT Baseline: </span><xsl:value-of select="AutoCT_Baseline"/>
	   <span style="color:#e38a22;font-weight:normal"> AutoCT Threshold: </span><xsl:value-of select="AutoCT_Threshold"/>
         </div>
						
    </xsl:for-each>
    
   <div style="color:#003366;font-weight:bold"> 
        	Markers: <xsl:value-of select="AB_Root/Data/Markers_List/Markers_Size"/></div>

    <xsl:for-each select="AB_Root/Data/Markers_List/Marker">
     <div style="color:#336699;padding:4px">
		<span style="color:#e38a22;font-weight:normal">Marker: </span><xsl:value-of select="Name"/>
	   <span style="color:#e38a22;font-weight:normal"> Description: </span><xsl:value-of select="Description"/>
	   <span style="color:#e38a22;font-weight:normal"> Color: </span><xsl:value-of select="Color"/>
	   <span style="color:#e38a22;font-weight:normal"> Allele X: </span><xsl:value-of select="Allele_X"/>
	   <span style="color:#e38a22;font-weight:normal"> Allele Y: </span><xsl:value-of select="Allele_Y"/>
	   <span style="color:#e38a22;font-weight:normal"> CV: </span><xsl:value-of select="CV"/>
	   <span style="color:#e38a22;font-weight:normal"> Owner: </span><xsl:value-of select="Owner"/>
	   <span style="color:#e38a22;font-weight:normal"> Comment: </span><xsl:value-of select="Comment"/>
	   <span style="color:#e38a22;font-weight:normal"> Auto CT: </span><xsl:value-of select="AutoCT"/>
	   <span style="color:#e38a22;font-weight:normal"> Cluster: </span><xsl:value-of select="Cluster"/>
      </div>
     </xsl:for-each>

   <div style="color:#003366;font-weight:bold"> 
        	Required Dyes: <xsl:value-of select="AB_Root/Data/Required_Dyes/Dyes_Size"/></div>

    <xsl:for-each select="AB_Root/Data/Required_Dyes/Dye">
     <div style="color:#336699;padding:4px">
		<span style="color:#e38a22;font-weight:normal">Dye Name: </span><xsl:value-of select="Name"/>
      </div>
     </xsl:for-each>

   <div style="color:#003366;font-weight:bold;padding:4px"> 
        	Thermal Cycler Program: <xsl:value-of select="AB_Root/Data/Thermocycle_Program/Value"/></div>

	<div style="color:#003366;font-weight:bold;padding:4px"> 
        	Calibration Plate Size: <xsl:value-of select="AB_Root/Data/Calibration_List/Plate_Size"/></div>
	<span style="color:#e38a22;font-weight:normal">Spectral Channels: </span><xsl:value-of select="AB_Root/Data/Calibration_List/Channel_Count"/>
	<span style="color:#e38a22;font-weight:normal"> Version: </span><xsl:value-of select="AB_Root/Data/Calibration_List/Version"/>
	<span style="color:#e38a22;font-weight:normal"> Exposure Time: </span><xsl:value-of select="AB_Root/Data/Calibration_List/Exposure_Time"/>
	
    <xsl:for-each select="AB_Root/Data/Components_List">
     <div style="color:#336699;padding:4px">
	 <span style="color:#e38a22;font-weight:normal">Components List: </span><xsl:value-of select="Value"/>
	 </div>
     <xsl:for-each select="Component">
        <div style="margin-left:20px;margin-bottom:2px">
        <span style="color:#003366;font-weight:normal;font-style:italic">Component: </span><xsl:value-of select="Value"/>
        </div>
    </xsl:for-each>
    </xsl:for-each>

   <xsl:for-each select="AB_Root/Data/Calibration_List/Components_List">
     <div style="color:#336699;padding:4px">
	 <span style="color:#e38a22;font-weight:normal">Components List: </span><xsl:value-of select="Value"/>
	 </div>
     <xsl:for-each select="Component">
        <div style="margin-left:20px;margin-bottom:2px">
        <span style="color:#003366;font-weight:normal;font-style:italic">Component: </span><xsl:value-of select="Value"/>
        </div>
    </xsl:for-each>
    </xsl:for-each>

  </body>
</html>
